#version 330
uniform sampler2D postProductionTexture;
uniform sampler2D brightPassTexture;
in vec2 fragmentUV;

layout(location = 0) out vec4 fragmentColor;

void main(void)
{
	vec4 tmp = texture(brightPassTexture, vec2(fragmentUV.x, 1 - fragmentUV.y));
	vec4 post = texture(postProductionTexture, vec2(fragmentUV.x, 1 - fragmentUV.y));
	float gray = 0.499 * tmp.x + 0.387*tmp.y + 0.114*tmp.z;
	vec4 bloom = gray > 0.95 ? tmp : vec4(0,0,0,0);
	
	fragmentColor = min(bloom + post, 1.0);
	//fragmentColor = clamp((bloom + post) - (bloom * post), 0.0, 1.0);
}

