#version 150

in vec4 position;
in vec4 color;
in vec2 uv;

out vec2 vTexCoord;
out float translucency;

uniform mat4 viewProjectionMatrix;
uniform vec3 cameraRight_worldspace;
uniform vec3 cameraUp_worldspace;
uniform vec3 billboardPosition;
uniform vec2 billboardSize;
uniform vec2 uvOffset;
uniform float transparency;

void main(void)
{
	vec3 particleCenter_worldspace = billboardPosition;

	vec3 vertexPosition_worldspace = particleCenter_worldspace +
									 cameraRight_worldspace * position.x * billboardSize.x +
									 cameraUp_worldspace * position.y * billboardSize.y;

	gl_Position = viewProjectionMatrix * vec4(vertexPosition_worldspace, 1.0f);
	//gl_Position = position;
	vTexCoord = uv + uvOffset;
	translucency = transparency;
}