#version 150

in vec4 position;
in vec4 color;
in vec2 uv;

out vec2 vTexCoord;


uniform mat4 viewProjectionMatrix;
uniform vec3 cameraRight_worldspace;
uniform vec3 cameraUp_worldspace;
uniform vec3 billboardPosition;
uniform float billboardSize;
uniform float uvOffset;

void main(void)
{
	vec3 particleCenter_worldspace = billboardPosition;

	vec3 vertexPosition_worldspace = particleCenter_worldspace +
									 cameraRight_worldspace * position.x * billboardSize +
									 cameraUp_worldspace * position.y * billboardSize;

	gl_Position = viewProjectionMatrix * vec4(vertexPosition_worldspace, 1.0f);
	//gl_Position = position;
	vTexCoord = uv + vec2(uvOffset, uvOffset);
}